### Method

# Gio File delete

#### Declaration

    gboolean
    g_file_delete (
      GFile* file,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Deletes a file. If the `file` is a directory, it will only be deleted if it is empty. This has the same semantics as g_unlink().

If `file` doesn’t exist, `G_IO_ERROR_NOT_FOUND` will be returned. This allows for deletion to be implemented avoiding time-of-check to time-of-use races:

    g_autoptr(GError) local_error = NULL;
    if (!g_file_delete (my_file, my_cancellable, &local_error) &&
        !g_error_matches (local_error, G_IO_ERROR, G_IO_ERROR_NOT_FOUND))
      {
        // deletion failed for some reason other than the file not existing:
        // so report the error
        g_warning ("Failed to delete %s: %s",
                   g_file_peek_path (my_file), local_error->message);
      }

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned.

#### Parameters

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` if the file was deleted. `FALSE` otherwise.